/*----- PROTECTED REGION ID(CanberraAIM556Class.cpp) ENABLED START -----*/
static const char *RcsId      = "$Id:  $";
static const char *TagName    = "$Name:  $";
static const char *CvsPath    = "$Source:  $";
static const char *SvnPath    = "$HeadURL:  $";
static const char *HttpServer = "http://www.esrf.eu/computing/cs/tango/tango_doc/ds_doc/";
//=============================================================================
//
// file :        CanberraAIM556Class.cpp
//
// description : C++ source for the CanberraAIM556Class.
//               A singleton class derived from DeviceClass.
//               It implements the command and attribute list
//               and all properties and methods required
//               by the CanberraAIM556 once per process.
//
// project :     MCA Canberra AIM 556
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#include <CanberraAIM556Class.h>

/*----- PROTECTED REGION END -----*/	//	CanberraAIM556Class.cpp

//-------------------------------------------------------------------
/**
 *	Create CanberraAIM556Class singleton and
 *	return it in a C function for Python usage
 */
//-------------------------------------------------------------------
extern "C" {
#ifdef _TG_WINDOWS_

__declspec(dllexport)

#endif

	Tango::DeviceClass *_create_CanberraAIM556_class(const char *name) {
		return CanberraAIM556_ns::CanberraAIM556Class::init(name);
	}
}

namespace CanberraAIM556_ns
{
//===================================================================
//	Initialize pointer for singleton pattern
//===================================================================
CanberraAIM556Class *CanberraAIM556Class::_instance = NULL;

//--------------------------------------------------------
/**
 * method : 		CanberraAIM556Class::CanberraAIM556Class(string &s)
 * description : 	constructor for the CanberraAIM556Class
 *
 * @param s	The class name
 */
//--------------------------------------------------------
CanberraAIM556Class::CanberraAIM556Class(string &s):Tango::DeviceClass(s)
{
	cout2 << "Entering CanberraAIM556Class constructor" << endl;
	set_default_property();
	write_class_property();

	/*----- PROTECTED REGION ID(CanberraAIM556Class::constructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CanberraAIM556Class::constructor

	cout2 << "Leaving CanberraAIM556Class constructor" << endl;
}

//--------------------------------------------------------
/**
 * method : 		CanberraAIM556Class::~CanberraAIM556Class()
 * description : 	destructor for the CanberraAIM556Class
 */
//--------------------------------------------------------
CanberraAIM556Class::~CanberraAIM556Class()
{
	/*----- PROTECTED REGION ID(CanberraAIM556Class::destructor) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CanberraAIM556Class::destructor

	_instance = NULL;
}


//--------------------------------------------------------
/**
 * method : 		CanberraAIM556Class::init
 * description : 	Create the object if not already done.
 *                  Otherwise, just return a pointer to the object
 *
 * @param	name	The class name
 */
//--------------------------------------------------------
CanberraAIM556Class *CanberraAIM556Class::init(const char *name)
{
	if (_instance == NULL)
	{
		try
		{
			string s(name);
			_instance = new CanberraAIM556Class(s);
		}
		catch (bad_alloc &)
		{
			throw;
		}
	}
	return _instance;
}

//--------------------------------------------------------
/**
 * method : 		CanberraAIM556Class::instance
 * description : 	Check if object already created,
 *                  and return a pointer to the object
 */
//--------------------------------------------------------
CanberraAIM556Class *CanberraAIM556Class::instance()
{
	if (_instance == NULL)
	{
		cerr << "Class is not initialised !!" << endl;
		exit(-1);
	}
	return _instance;
}



//===================================================================
//	Command execution method calls
//===================================================================
//--------------------------------------------------------
/**
 * method : 		OnClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *OnClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "OnClass::execute(): arrived" << endl;
	((static_cast<CanberraAIM556 *>(device))->on());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		OffClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *OffClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "OffClass::execute(): arrived" << endl;
	((static_cast<CanberraAIM556 *>(device))->off());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		ResetClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *ResetClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "ResetClass::execute(): arrived" << endl;
	((static_cast<CanberraAIM556 *>(device))->reset());
	return new CORBA::Any();
}

//--------------------------------------------------------
/**
 * method : 		ClearMemoryClass::execute()
 * description : 	method to trigger the execution of the command.
 *
 * @param	device	The device on which the command must be executed
 * @param	in_any	The command input data
 *
 *	returns The command output data (packed in the Any object)
 */
//--------------------------------------------------------
CORBA::Any *ClearMemoryClass::execute(Tango::DeviceImpl *device, TANGO_UNUSED(const CORBA::Any &in_any))
{
	cout2 << "ClearMemoryClass::execute(): arrived" << endl;
	((static_cast<CanberraAIM556 *>(device))->clear_memory());
	return new CORBA::Any();
}


//===================================================================
//	Properties management
//===================================================================
//--------------------------------------------------------
/**
 *	Method      : CanberraAIM556Class::get_class_property()
 *	Description : Get the class property for specified name.
 */
//--------------------------------------------------------
Tango::DbDatum CanberraAIM556Class::get_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_prop.size() ; i++)
		if (cl_prop[i].name == prop_name)
			return cl_prop[i];
	//	if not found, returns  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : CanberraAIM556Class::get_default_device_property()
 *	Description : Return the default value for device property.
 */
//--------------------------------------------------------
Tango::DbDatum CanberraAIM556Class::get_default_device_property(string &prop_name)
{
	for (unsigned int i=0 ; i<dev_def_prop.size() ; i++)
		if (dev_def_prop[i].name == prop_name)
			return dev_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}

//--------------------------------------------------------
/**
 *	Method      : CanberraAIM556Class::get_default_class_property()
 *	Description : Return the default value for class property.
 */
//--------------------------------------------------------
Tango::DbDatum CanberraAIM556Class::get_default_class_property(string &prop_name)
{
	for (unsigned int i=0 ; i<cl_def_prop.size() ; i++)
		if (cl_def_prop[i].name == prop_name)
			return cl_def_prop[i];
	//	if not found, return  an empty DbDatum
	return Tango::DbDatum(prop_name);
}


//--------------------------------------------------------
/**
 *	Method      : CanberraAIM556Class::set_default_property()
 *	Description : Set default property (class and device) for wizard.
 *                For each property, add to wizard property name and description.
 *                If default value has been set, add it to wizard property and
 *                store it in a DbDatum.
 */
//--------------------------------------------------------
void CanberraAIM556Class::set_default_property()
{
	string	prop_name;
	string	prop_desc;
	string	prop_def;
	vector<string>	vect_data;

	//	Set Default Class Properties

	//	Set Default device Properties
	prop_name = "Address";
	prop_desc = "Address suffix of the AIM. (Eg. 0x08E0)";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
	prop_name = "Interface";
	prop_desc = "Network interface name (eg. eth0)";
	prop_def  = "";
	vect_data.clear();
	if (prop_def.length()>0)
	{
		Tango::DbDatum	data(prop_name);
		data << vect_data ;
		dev_def_prop.push_back(data);
		add_wiz_dev_prop(prop_name, prop_desc,  prop_def);
	}
	else
		add_wiz_dev_prop(prop_name, prop_desc);
}

//--------------------------------------------------------
/**
 *	Method      : CanberraAIM556Class::write_class_property()
 *	Description : Set class description fields as property in database
 */
//--------------------------------------------------------
void CanberraAIM556Class::write_class_property()
{
	//	First time, check if database used
	if (Tango::Util::_UseDb == false)
		return;

	Tango::DbData	data;
	string	classname = get_name();
	string	header;
	string::size_type	start, end;

	//	Put title
	Tango::DbDatum	title("ProjectTitle");
	string	str_title("MCA Canberra AIM 556");
	title << str_title;
	data.push_back(title);

	//	Put Description
	Tango::DbDatum	description("Description");
	vector<string>	str_desc;
	str_desc.push_back("A class to control the MCA Canberra AIM 556 (A ou B).");
	description << str_desc;
	data.push_back(description);

	//  Put inheritance
	Tango::DbDatum	inher_datum("InheritedFrom");
	vector<string> inheritance;
	inheritance.push_back("TANGO_BASE_CLASS");
	inher_datum << inheritance;
	data.push_back(inher_datum);

	//	Call database and and values
	get_db_class()->put_property(data);
}

//===================================================================
//	Factory methods
//===================================================================

//--------------------------------------------------------
/**
 *	Method      : CanberraAIM556Class::device_factory()
 *	Description : Create the device object(s)
 *                and store them in the device list
 */
//--------------------------------------------------------
void CanberraAIM556Class::device_factory(const Tango::DevVarStringArray *devlist_ptr)
{
	/*----- PROTECTED REGION ID(CanberraAIM556Class::device_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	CanberraAIM556Class::device_factory_before

	//	Create devices and add it into the device list
	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		cout4 << "Device name : " << (*devlist_ptr)[i].in() << endl;
		device_list.push_back(new CanberraAIM556(this, (*devlist_ptr)[i]));
	}

	//	Manage dynamic attributes if any
	erase_dynamic_attributes(devlist_ptr, get_class_attr()->get_attr_list());

	//	Export devices to the outside world
	for (unsigned long i=1 ; i<=devlist_ptr->length() ; i++)
	{
		//	Add dynamic attributes if any
		CanberraAIM556 *dev = static_cast<CanberraAIM556 *>(device_list[device_list.size()-i]);
		dev->add_dynamic_attributes();

		//	Check before if database used.
		if ((Tango::Util::_UseDb == true) && (Tango::Util::_FileDb == false))
			export_device(dev);
		else
			export_device(dev, dev->get_name().c_str());
	}

	/*----- PROTECTED REGION ID(CanberraAIM556Class::device_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	CanberraAIM556Class::device_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : CanberraAIM556Class::attribute_factory()
 *	Description : Create the attribute object(s)
 *                and store them in the attribute list
 */
//--------------------------------------------------------
void CanberraAIM556Class::attribute_factory(vector<Tango::Attr *> &att_list)
{
	/*----- PROTECTED REGION ID(CanberraAIM556Class::attribute_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	CanberraAIM556Class::attribute_factory_before
	//	Attribute : ADC
	ADCAttrib	*adc = new ADCAttrib();
	Tango::UserDefaultAttrProp	adc_prop;
	adc_prop.set_description("ADC index (0..1)");
	adc_prop.set_label("ADC index");
	//	unit	not set for ADC
	//	standard_unit	not set for ADC
	//	display_unit	not set for ADC
	adc_prop.set_format("%1d");
	//	max_value	not set for ADC
	//	min_value	not set for ADC
	//	max_alarm	not set for ADC
	//	min_alarm	not set for ADC
	//	max_warning	not set for ADC
	//	min_warning	not set for ADC
	//	delta_t	not set for ADC
	//	delta_val	not set for ADC
	
	adc->set_default_properties(adc_prop);
	//	Not Polled
	adc->set_disp_level(Tango::OPERATOR);
	adc->set_memorized();
	adc->set_memorized_init(false);
	att_list.push_back(adc);

	//	Attribute : Mode
	ModeAttrib	*mode = new ModeAttrib();
	Tango::UserDefaultAttrProp	mode_prop;
	mode_prop.set_description("Acquisition Mode\n0 -> PHA\n1 -> PHA LFC\n2 -> DBL BUFFERS");
	mode_prop.set_label("Acquisition Mode");
	//	unit	not set for Mode
	//	standard_unit	not set for Mode
	//	display_unit	not set for Mode
	//	format	not set for Mode
	//	max_value	not set for Mode
	//	min_value	not set for Mode
	//	max_alarm	not set for Mode
	//	min_alarm	not set for Mode
	//	max_warning	not set for Mode
	//	min_warning	not set for Mode
	//	delta_t	not set for Mode
	//	delta_val	not set for Mode
	
	{
		vector<string> labels;
		labels.push_back("PHA");
		labels.push_back("MCS");
		labels.push_back("LIST");
		mode_prop.set_enum_labels(labels);
	}
	mode->set_default_properties(mode_prop);
	//	Not Polled
	mode->set_disp_level(Tango::OPERATOR);
	mode->set_memorized();
	mode->set_memorized_init(false);
	att_list.push_back(mode);

	//	Attribute : Channels
	ChannelsAttrib	*channels = new ChannelsAttrib();
	Tango::UserDefaultAttrProp	channels_prop;
	channels_prop.set_description("Channel number");
	//	label	not set for Channels
	//	unit	not set for Channels
	//	standard_unit	not set for Channels
	//	display_unit	not set for Channels
	//	format	not set for Channels
	//	max_value	not set for Channels
	//	min_value	not set for Channels
	//	max_alarm	not set for Channels
	//	min_alarm	not set for Channels
	//	max_warning	not set for Channels
	//	min_warning	not set for Channels
	//	delta_t	not set for Channels
	//	delta_val	not set for Channels
	
	channels->set_default_properties(channels_prop);
	//	Not Polled
	channels->set_disp_level(Tango::OPERATOR);
	channels->set_memorized();
	channels->set_memorized_init(false);
	att_list.push_back(channels);

	//	Attribute : PresetLiveTime
	PresetLiveTimeAttrib	*presetlivetime = new PresetLiveTimeAttrib();
	Tango::UserDefaultAttrProp	presetlivetime_prop;
	presetlivetime_prop.set_description("Preset live time");
	presetlivetime_prop.set_label("Acquisition Time Limit (Real)");
	presetlivetime_prop.set_unit("s");
	//	standard_unit	not set for PresetLiveTime
	//	display_unit	not set for PresetLiveTime
	//	format	not set for PresetLiveTime
	//	max_value	not set for PresetLiveTime
	//	min_value	not set for PresetLiveTime
	//	max_alarm	not set for PresetLiveTime
	//	min_alarm	not set for PresetLiveTime
	//	max_warning	not set for PresetLiveTime
	//	min_warning	not set for PresetLiveTime
	//	delta_t	not set for PresetLiveTime
	//	delta_val	not set for PresetLiveTime
	
	presetlivetime->set_default_properties(presetlivetime_prop);
	//	Not Polled
	presetlivetime->set_disp_level(Tango::OPERATOR);
	presetlivetime->set_memorized();
	presetlivetime->set_memorized_init(false);
	att_list.push_back(presetlivetime);

	//	Attribute : PresetRealTime
	PresetRealTimeAttrib	*presetrealtime = new PresetRealTimeAttrib();
	Tango::UserDefaultAttrProp	presetrealtime_prop;
	//	description	not set for PresetRealTime
	presetrealtime_prop.set_label("Acquisition Time Limt (Live)");
	presetrealtime_prop.set_unit("s");
	//	standard_unit	not set for PresetRealTime
	//	display_unit	not set for PresetRealTime
	//	format	not set for PresetRealTime
	//	max_value	not set for PresetRealTime
	//	min_value	not set for PresetRealTime
	//	max_alarm	not set for PresetRealTime
	//	min_alarm	not set for PresetRealTime
	//	max_warning	not set for PresetRealTime
	//	min_warning	not set for PresetRealTime
	//	delta_t	not set for PresetRealTime
	//	delta_val	not set for PresetRealTime
	
	presetrealtime->set_default_properties(presetrealtime_prop);
	//	Not Polled
	presetrealtime->set_disp_level(Tango::OPERATOR);
	presetrealtime->set_memorized();
	presetrealtime->set_memorized_init(false);
	att_list.push_back(presetrealtime);

	//	Attribute : LiveTime
	LiveTimeAttrib	*livetime = new LiveTimeAttrib();
	Tango::UserDefaultAttrProp	livetime_prop;
	//	description	not set for LiveTime
	//	label	not set for LiveTime
	livetime_prop.set_unit("s");
	//	standard_unit	not set for LiveTime
	//	display_unit	not set for LiveTime
	//	format	not set for LiveTime
	//	max_value	not set for LiveTime
	//	min_value	not set for LiveTime
	//	max_alarm	not set for LiveTime
	//	min_alarm	not set for LiveTime
	//	max_warning	not set for LiveTime
	//	min_warning	not set for LiveTime
	//	delta_t	not set for LiveTime
	//	delta_val	not set for LiveTime
	
	livetime->set_default_properties(livetime_prop);
	//	Not Polled
	livetime->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(livetime);

	//	Attribute : RealTime
	RealTimeAttrib	*realtime = new RealTimeAttrib();
	Tango::UserDefaultAttrProp	realtime_prop;
	//	description	not set for RealTime
	//	label	not set for RealTime
	realtime_prop.set_unit("s");
	//	standard_unit	not set for RealTime
	//	display_unit	not set for RealTime
	//	format	not set for RealTime
	//	max_value	not set for RealTime
	//	min_value	not set for RealTime
	//	max_alarm	not set for RealTime
	//	min_alarm	not set for RealTime
	//	max_warning	not set for RealTime
	//	min_warning	not set for RealTime
	//	delta_t	not set for RealTime
	//	delta_val	not set for RealTime
	
	realtime->set_default_properties(realtime_prop);
	//	Not Polled
	realtime->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(realtime);

	//	Attribute : Data
	DataAttrib	*data = new DataAttrib();
	Tango::UserDefaultAttrProp	data_prop;
	//	description	not set for Data
	//	label	not set for Data
	//	unit	not set for Data
	//	standard_unit	not set for Data
	//	display_unit	not set for Data
	//	format	not set for Data
	//	max_value	not set for Data
	//	min_value	not set for Data
	//	max_alarm	not set for Data
	//	min_alarm	not set for Data
	//	max_warning	not set for Data
	//	min_warning	not set for Data
	//	delta_t	not set for Data
	//	delta_val	not set for Data
	
	data->set_default_properties(data_prop);
	//	Not Polled
	data->set_disp_level(Tango::OPERATOR);
	//	Not Memorized
	att_list.push_back(data);


	//	Create a list of static attributes
	create_static_attribute_list(get_class_attr()->get_attr_list());
	/*----- PROTECTED REGION ID(CanberraAIM556Class::attribute_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	CanberraAIM556Class::attribute_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : CanberraAIM556Class::pipe_factory()
 *	Description : Create the pipe object(s)
 *                and store them in the pipe list
 */
//--------------------------------------------------------
void CanberraAIM556Class::pipe_factory()
{
	/*----- PROTECTED REGION ID(CanberraAIM556Class::pipe_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	CanberraAIM556Class::pipe_factory_before
	/*----- PROTECTED REGION ID(CanberraAIM556Class::pipe_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	CanberraAIM556Class::pipe_factory_after
}
//--------------------------------------------------------
/**
 *	Method      : CanberraAIM556Class::command_factory()
 *	Description : Create the command object(s)
 *                and store them in the command list
 */
//--------------------------------------------------------
void CanberraAIM556Class::command_factory()
{
	/*----- PROTECTED REGION ID(CanberraAIM556Class::command_factory_before) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	CanberraAIM556Class::command_factory_before


	//	Command On
	OnClass	*pOnCmd =
		new OnClass("On",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pOnCmd);

	//	Command Off
	OffClass	*pOffCmd =
		new OffClass("Off",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pOffCmd);

	//	Command Reset
	ResetClass	*pResetCmd =
		new ResetClass("Reset",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pResetCmd);

	//	Command ClearMemory
	ClearMemoryClass	*pClearMemoryCmd =
		new ClearMemoryClass("ClearMemory",
			Tango::DEV_VOID, Tango::DEV_VOID,
			"",
			"",
			Tango::OPERATOR);
	command_list.push_back(pClearMemoryCmd);

	/*----- PROTECTED REGION ID(CanberraAIM556Class::command_factory_after) ENABLED START -----*/
	
	//	Add your own code
	
	/*----- PROTECTED REGION END -----*/	//	CanberraAIM556Class::command_factory_after
}

//===================================================================
//	Dynamic attributes related methods
//===================================================================

//--------------------------------------------------------
/**
 * method : 		CanberraAIM556Class::create_static_attribute_list
 * description : 	Create the a list of static attributes
 *
 * @param	att_list	the ceated attribute list
 */
//--------------------------------------------------------
void CanberraAIM556Class::create_static_attribute_list(vector<Tango::Attr *> &att_list)
{
	for (unsigned long i=0 ; i<att_list.size() ; i++)
	{
		string att_name(att_list[i]->get_name());
		transform(att_name.begin(), att_name.end(), att_name.begin(), ::tolower);
		defaultAttList.push_back(att_name);
	}

	cout2 << defaultAttList.size() << " attributes in default list" << endl;

	/*----- PROTECTED REGION ID(CanberraAIM556Class::create_static_att_list) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CanberraAIM556Class::create_static_att_list
}


//--------------------------------------------------------
/**
 * method : 		CanberraAIM556Class::erase_dynamic_attributes
 * description : 	delete the dynamic attributes if any.
 *
 * @param	devlist_ptr	the device list pointer
 * @param	list of all attributes
 */
//--------------------------------------------------------
void CanberraAIM556Class::erase_dynamic_attributes(const Tango::DevVarStringArray *devlist_ptr, vector<Tango::Attr *> &att_list)
{
	Tango::Util *tg = Tango::Util::instance();

	for (unsigned long i=0 ; i<devlist_ptr->length() ; i++)
	{
		Tango::DeviceImpl *dev_impl = tg->get_device_by_name(((string)(*devlist_ptr)[i]).c_str());
		CanberraAIM556 *dev = static_cast<CanberraAIM556 *> (dev_impl);

		vector<Tango::Attribute *> &dev_att_list = dev->get_device_attr()->get_attribute_list();
		vector<Tango::Attribute *>::iterator ite_att;
		for (ite_att=dev_att_list.begin() ; ite_att != dev_att_list.end() ; ++ite_att)
		{
			string att_name((*ite_att)->get_name_lower());
			if ((att_name == "state") || (att_name == "status"))
				continue;
			vector<string>::iterator ite_str = find(defaultAttList.begin(), defaultAttList.end(), att_name);
			if (ite_str == defaultAttList.end())
			{
				cout2 << att_name << " is a UNWANTED dynamic attribute for device " << (*devlist_ptr)[i] << endl;
				Tango::Attribute &att = dev->get_device_attr()->get_attr_by_name(att_name.c_str());
				dev->remove_attribute(att_list[att.get_attr_idx()], true, false);
				--ite_att;
			}
		}
	}
	/*----- PROTECTED REGION ID(CanberraAIM556Class::erase_dynamic_attributes) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	CanberraAIM556Class::erase_dynamic_attributes
}

//--------------------------------------------------------
/**
 *	Method      : CanberraAIM556Class::get_attr_object_by_name()
 *	Description : returns Tango::Attr * object found by name
 */
//--------------------------------------------------------
Tango::Attr *CanberraAIM556Class::get_attr_object_by_name(vector<Tango::Attr *> &att_list, string attname)
{
	vector<Tango::Attr *>::iterator it;
	for (it=att_list.begin() ; it<att_list.end() ; ++it)
		if ((*it)->get_name()==attname)
			return (*it);
	//	Attr does not exist
	return NULL;
}


/*----- PROTECTED REGION ID(CanberraAIM556Class::Additional Methods) ENABLED START -----*/

/*----- PROTECTED REGION END -----*/	//	CanberraAIM556Class::Additional Methods
} //	namespace
